> ## Documentation Index
> Fetch the complete documentation index at: https://apidocs.specurate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Turn



## OpenAPI

````yaml /openapi.json post /v1/workspaces/{workspaceId}/assistant/conversations/{conversationId}/turns
openapi: 3.1.0
info:
  title: Specurate API
  description: ''
  version: 1.0.0
  contact: {}
servers:
  - url: https://app.specurate.com/api
    description: API Server
security: []
tags: []
paths:
  /v1/workspaces/{workspaceId}/assistant/conversations/{conversationId}/turns:
    post:
      tags:
        - Assistant Conversations
      summary: Turn
      operationId: AssistantConversationsController_turn_v1
      parameters:
        - name: workspaceId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d*$
        - name: conversationId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d*$
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AssistantTurnBodyDto'
      responses:
        '200':
          description: ''
components:
  schemas:
    AssistantTurnBodyDto:
      type: object
      properties:
        clientTurnId:
          type: string
          pattern: >-
            ^[0-9a-f]{8}-[0-9a-f]{4}-[1-8][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}$
        routeKey:
          type: string
          enum:
            - project-specifications
            - data-import
            - report-templates
        projectId:
          type: string
          pattern: ^[1-9]\d*$
        message:
          type: string
        documentIds:
          maxItems: 3
          type: array
          items:
            type: string
            pattern: ^[1-9]\d*$
        editor:
          type: object
          properties:
            templateId:
              type: string
              pattern: ^[1-9]\d*$
            archetype:
              type: string
              minLength: 1
              maxLength: 40
            version:
              type: integer
              exclusiveMinimum: 0
              maximum: 9007199254740991
            workingCopyRevision:
              type: string
              minLength: 1
              maxLength: 100
            draftSettings:
              type: object
              propertyNames:
                type: string
              additionalProperties: {}
            selection:
              type: object
              properties:
                page:
                  type: string
                  minLength: 1
                  maxLength: 100
                variantId:
                  type: string
                  minLength: 1
                  maxLength: 200
                blockId:
                  type: string
                  minLength: 1
                  maxLength: 200
              required:
                - page
              additionalProperties: false
            lastRenderFeedback:
              type: object
              properties:
                warnings:
                  maxItems: 100
                  type: array
                  items:
                    type: string
                    maxLength: 500
                overflow:
                  maxItems: 1000
                  type: array
                  items:
                    type: string
                    maxLength: 200
                revertedDraftId:
                  type: string
                  minLength: 1
                  maxLength: 200
                refusedDraftId:
                  type: string
                  minLength: 1
                  maxLength: 200
              required:
                - warnings
                - overflow
              additionalProperties: false
          required:
            - templateId
            - archetype
            - version
            - draftSettings
          additionalProperties: false
        dataImport:
          type: object
          properties:
            step:
              type: string
              enum:
                - prepare
                - upload
                - sheet
                - headers
                - category-column
                - mapping:columns
                - mapping:areas
                - mapping:categories
                - mapping:manufacturers
                - mapping:suppliers
                - mapping-complete
                - review
                - summary
                - analysis
                - failure
          required:
            - step
          additionalProperties: false
      required:
        - clientTurnId
        - routeKey
        - message
        - documentIds
      additionalProperties: false

````